package com.lantone.qc.kernel.catalogue.behospitalized;

import com.lantone.qc.kernel.catalogue.QCCatalogue;
import com.lantone.qc.kernel.util.CatalogueUtil;
import com.lantone.qc.pub.model.InputInfo;
import com.lantone.qc.pub.model.OutputInfo;
import com.lantone.qc.pub.model.entity.Clinical;
import com.lantone.qc.pub.model.entity.PD;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName : BEH0001
 * @Description : 症状缺少时间描述
 * @Author : 楼辉荣
 * @Date: 2020-03-06 17:28
 */
@Component
public class BEH0001 extends QCCatalogue {
    public void start(InputInfo inputInfo, OutputInfo outputInfo) {
        Map<String,String> statusMap = new HashMap<>();
        String status = "0";
        String infos = "";
        List<Clinical> clinicals = inputInfo.getBeHospitalizedDoc().getChiefLabel().getClinicals();
        if(clinicals.size()>0){
            for (Clinical clinical:clinicals) {
                String clinicalName = clinical.getName();
                List<PD> timestamp = clinical.getTimestamp();
                if(timestamp == null){
                    infos = infos+","+clinicalName;
                }
            }
        }
        if(StringUtils.isNotEmpty(infos)){
            status = "-1";
        }
        statusMap.put("status",status);
        statusMap.put("info",infos);
        Map<String, Map<String, String>> result = outputInfo.getResult();
        result.put("BEH0001",statusMap);
        outputInfo.setResult(result);
    }
}