package com.lantone.qc.kernel.structure.ai.process;


import com.alibaba.fastjson.JSONObject;
import com.lantone.qc.kernel.structure.ai.model.CrfOut;
import com.lantone.qc.kernel.structure.ai.model.EntityEnum;
import com.lantone.qc.pub.model.InputInfo;
import com.lantone.qc.pub.model.entity.*;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class EntityProcessClinic extends EntityProcess {
    public List<Clinical> extractEntity(JSONObject aiOut) {
        List<Clinical> clinicals = new ArrayList<>();
        Clinical clinical;
        List<Map<String, String>> clinicalEntityList = processJson(aiOut, EntityEnum.CLINICAL_FEATURE.toString());
        for (Map<String, String> clinicalEntityEntry : clinicalEntityList) {
            if (StringUtils.isEmpty(clinicalEntityEntry.get(EntityEnum.CLINICAL_FEATURE.toString()))) {
                continue;
            }
            clinical = new Clinical();
            for (String key : clinicalEntityEntry.keySet()) {
                String entity = StringUtils.isEmpty(clinicalEntityEntry.get(key)) ? "" : clinicalEntityEntry.get(key);
                switch (EntityEnum.parseOfValue(key)){
                    case CLINICAL_FEATURE:
                        clinical.setName(clinicalEntityEntry.get(key));
                        break;
                    case NEGATIVE:
                        Negative negative = new Negative();
                        negative.setName(entity);
                        clinical.setNegative(negative);
                        break;
                    case BODY:
                        BodyPart bodyPart = new BodyPart();
                        bodyPart.setName(entity);
                        clinical.setBodyPart(bodyPart);
                    case TREND:
                        Trend trend = new Trend();
                        trend.setName(entity);
                        clinical.setTrend(trend);
                    case CAUSE:
                        Cause cause = new Cause();
                        cause.setName(entity);
                        clinical.setCause(cause);
                    case TIME:
                        List<PD> timestamp = new ArrayList<>();
                        PD pd = new PD();
                        String[] val_unit = new String[2];
                        if(entity.trim().length()>0){
                            val_unit = extract_digit(entity);
                        }
                        pd.setValue(val_unit[0]);
                        pd.setUnit(val_unit[1]);
                        timestamp.add(pd);
                        clinical.setTimestamp(timestamp);
                        break;

                }

            }
            clinicals.add(clinical);
        }
        return clinicals;
    }
}
