package com.lantone.qc.kernel.structure.ai.process;


import com.alibaba.fastjson.JSONObject;
import com.lantone.qc.kernel.structure.ai.model.EntityEnum;
import com.lantone.qc.pub.model.entity.*;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class EntityProcessFamily extends EntityProcess {
    public List<Family> extractEntity(JSONObject aiOut) {
        List<Family> families = new ArrayList<>();
        Family family;
        Dead dead;
        List<Map<String, String>> clinicalEntityList = processJson(aiOut, EntityEnum.RELATIVES.toString());
        for (Map<String, String> clinicalEntityEntry : clinicalEntityList) {
            if (StringUtils.isEmpty(clinicalEntityEntry.get(EntityEnum.RELATIVES.toString()))) {
                continue;
            }
            family = new Family();
            dead = new Dead();
            for (String key : clinicalEntityEntry.keySet()) {
                String entity = StringUtils.isEmpty(clinicalEntityEntry.get(key)) ? "" : clinicalEntityEntry.get(key);
                switch (EntityEnum.parseOfValue(key)){
                    case RELATIVES:
                        family.setName(clinicalEntityEntry.get(key));
                        break;
                    case DEAD:
                        dead.setName(entity);
                        family.setDead(dead);
                        break;
                    case UNKNOWN:
                        Unknow unknow = new Unknow();
                        unknow.setName(entity);
                        dead.setUnknow(unknow);
                        break;

                }

            }
            families.add(family);
        }
        return families;
    }
}
